#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=ScapeSkate Beta 3
#AutoIt3Wrapper_Res_Description=ScapeSkate Beta 3
#AutoIt3Wrapper_Res_Fileversion=0.3.0.0
#AutoIt3Wrapper_Res_LegalCopyright=copyright DragonApps
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
FileChangeDir(@Scriptdir)


#include "VoiceOver.au3"

#include "GuiConstants.au3"
#include "Pureaudio.au3"
#include "Colorconstants.au3"
#include "pan.au3"
#include "Misc.au3"
#include "kbc.au3"
#include "Sapi.au3"
#include "Menu.au3"
GuiCreate("ScapeSkate ~ A DragonApps Game", @DesktopWidth+100, @DesktopHeight+100)
GuiSetBKColor($Color_Black)
GuiSetState()

$SayScore = 0
$Paused = 0
$MoveTimer = TimerInit()
$MusicVolume = -2000
$TempVar = 0
$TempVarTwo = 0
$Slowmotimer = 0
$CurrentKey = 0
$JustDidTrick = 0
$LoopTimer = TimerInit()
$NewbieMode = 0
$YourPos = 0
$Bumped = 0
$BumpedTimer = 0
dim $SpecialKeyPressed[20]
$KeyUp = 0
$KeyDown = 0
$KeyLeft = 0
$KeyRight = 0
$KeyA = 0
$KeyS = 0
$KeyD = 0
$KeyF = 0
$KeyJ = 0
$KeyK = 0
$KeyL = 0


dim $ToMoveTo[2]
$ToPipeTo = 0
$ToPipeFrom = 0
$Ready2Go = 0
$yourHealth = 100
$ToSetSpeed = 0.2
$SkateSpeed = 0.02
$Level = 0
$Score = 0
$Skating = 0
$Skatedirection = 1
$ChangeDirection = 0

$ChangeDirectionTimer = TimerInit()
$JustSkated = 0
$JustSkatedTimer = TimerInit()
$JumpsPerLevel = 1
$ObjectsPerLevel = 1
$Jumping = 0
$Jumptimer = 0
$Grinding = 0
$Fallen = 0
$FallenTimer = 0
dim $ItemActive[50]
dim $Item[50]
$SoundItemOne = s_Load("FX\Misc\Item.ogg")

$SoundItemTwo = s_Load("FX\Misc\getobject.ogg")
$ObjectSoundOne = s_Load("fx\misc\AreaStart.ogg")
$ObjectSoundTwo = s_Load("Fx\Misc\AreaEnd.ogg")
$Sound1 = s_Load("fx\menu\click.ogg")
$sound2 = s_Load("fx\menu\select.ogg")
$sound3 = s_Load("FX\Menu\Boundary.ogg")
$Sound4 = s_Load("fx\menu\appear.ogg")
dim $ItemSound[50][50]
dim $PipeStart[50]
dim $PipeEnd[50]
dim $PipeSound[50]
$Piping = 0
$PipesPerLevel = 5
dim $Objectstart[50]
dim $Objectend[50]
dim $ObjectStartSound[50]
dim $ObjectEndSound[50]
dim $FXAmbience[1]
$FXGetObject = 0
$FXPressedKey = s_load("FX\Misc\Click.ogg")
$FXWrongMove = s_load("FX\Misc\Fail.ogg")
dim $FXMisc[7]
dim $FXMusic[3]
dim $FXPlayer[4]
dim $FXSkate[18]
dim $FXSlowmo[8]
LoadSounds()
func LoadSounds()
clipput("loadsounds")
$IntroSound = s_Load("fx\misc\ssintro.ogg")
s_play($Introsound)

$FXGetObject = s_load("FX\Misc\GetObject.ogg")
$FXAmbience[0] = s_Load("FX\Ambience\ambience.ogg")
$FXMisc[0] = s_Load("fx\misc\AreaEnd.ogg")
$FXMisc[1] = s_Load("fx\misc\AreaStart.ogg")
$FXMisc[2] = s_Load("Fx\Misc\CrowdApplause.ogg")
$FXMisc[3] = s_Load("fx\misc\CrowdGasp.ogg")
$FXMisc[4] = s_Load("fx\misc\GettingUp.ogg")
$FXMisc[5] = s_Load("fx\misc\LevelEnd.ogg")
$FXMusic[0] = s_Load("fx\music\main.ogg")
$FXMusic[1] = s_Load("fx\music\menu.ogg")
$FXMusic[2] = s_Load("fx\music\pause.ogg")
$FXPlayer[0] = s_Load("fx\player\grunt.ogg")
$FXPlayer[1] = s_Load("fx\player\laugh.ogg")
$FXPlayer[2] = s_Load("fx\player\scream.ogg")
$FXPlayer[3] = s_load("FX\Player\Fall.ogg")
$FXSkate[0] = s_Load("FX\Skate\Crash1.ogg")
$FXSkate[1] = s_Load("FX\Skate\Crash2.ogg")
$FXSkate[2] = s_Load("FX\Skate\Crash3.ogg")
$FXSkate[3] = s_Load("FX\Skate\GrindMetal.ogg")
$FXSkate[4] = s_Load("FX\Skate\GrindRock.ogg")
$FXSkate[5] = s_Load("FX\Skate\jump1.ogg")
$FXSkate[6] = s_Load("FX\Skate\jump2.ogg")
$FXSkate[7] = s_Load("FX\Skate\jump3.ogg")
$FXSkate[8] = s_Load("FX\Skate\land1.ogg")
$FXSkate[9] = s_Load("FX\Skate\land2.ogg")
$FXSkate[10] = s_Load("FX\Skate\land3.ogg")
$FXSkate[11] = s_Load("FX\Skate\pushoff.ogg")
$FXSkate[12] = s_Load("FX\Skate\roll.ogg")
$FXSkate[13] = s_Load("FX\Skate\rollConc.ogg")
$FXSkate[14] = s_Load("FX\Skate\RollTiles.ogg")
$FXSkate[15] = s_Load("FX\Skate\Stop.ogg")
$FXSkate[16] = s_Load("FX\Skate\WBump.ogg")
$FXSkate[17] = s_Load("FX\Skate\LandPipe.ogg")
$FXSlowmo[0] = s_load("FX\SlowMo\Enter.ogg")
$FXSlowmo[1] = s_load("FX\SlowMo\exit.ogg")
$FXSlowmo[2] = s_load("FX\SlowMo\exiting.ogg")
$FXSlowmo[3] = s_load("FX\SlowMo\Loop.ogg")
$FXSlowmo[4] = s_load("FX\SlowMo\Woosh1.ogg")
$FXSlowmo[5] = s_load("FX\SlowMo\Woosh2.ogg")
$FXSlowmo[6] = s_load("FX\SlowMo\Woosh3.ogg")
$FXSlowmo[7] = s_load("FX\SlowMo\Woosh4.ogg")
while s_isplaying($IntroSound)
if _ispressed($spacebar) then s_stop($introsound)
sleep(4)
WEnd
s_free($introsound)
ShowMenu()
EndFunc
func ShowMenu()
clipput("showmenu")
if not s_isplaying($fxmusic[1]) then s_play($FXMusic[1], 1)
s_setVolume($FXMusic[1], -2000)
$menu = Createmenu("mainmenu.ogg", "StartGame.ogg|newbiemode.ogg|speakercalibration.ogg|Credits.ogg|quit.ogg")
select
case $menu = 0
showMenu()
Case $menu = 1
s_stop($fxmusic[1])
$JumpsPerLevel = 10
$ObjectsPerLevel = 20
$Level = 1
$Score = 0
$PipesPerLevel = 1
StartGame()
case $menu = 2
if $newbiemode = 0 then
$newbiemode = 1
vo("Newbiemode")
vo("on")
else
$newbiemode = 0
vo("Newbiemode")
vo("Off")
EndIf
ShowMenu()
Case $menu = 3
vo("Speakerl")
for $iload = 0 to -5000 step -20
s_setpan($fxmusic[1], $iload)
sleep(10)
Next
vo("Speakerl-r")
for $iload = -5000 to 5000 step 20
s_setpan($fxmusic[1], $iload)
sleep(10)
Next
vo("Speakerr")
sleep(500)
for $iload = 5000 to 0 step -20
s_setpan($fxmusic[1], $iload)
sleep(10)
Next
ShowMenu()
case $menu = 4
speak ("Credits")
speak ("Kevin, or Ghorthalon: Game design and development")
speak ("Tom, or Lirin: System voice")
speak ("Peter Mahacz, or pitermach: private tester, intro designer")
speak ("Rob, or Erion: private testing, developer of PureAudio")
speak ("Aaron, or Jukesy: private testing")
speak ("Bryan McKinish: private testing")
speak ("And you, for playing!")
ShowMenu()
Case $Menu = 5
s_stop($FXMusic[1])
Exit
EndSelect
EndFunc
func StartGame()
clipput("startgame")
$ToPipeTo = 0
$ToPipeFrom = 0
$paused = 0
$TempVar = 0
$YourPos = 0
$Bumped = 0
$BumpedTimer = 0
dim $ToMoveTo[2]
$Ready2Go = 0
$yourHealth = 100
$SkateSpeed = $toSetSpeed


$Skating = 0
$Skatedirection = 1
$ChangeDirection = 0
$ChangeDirectionTimer = TimerInit()
$JustSkated = 0
$JustSkatedTimer = TimerInit()

$Jumping = 0
$Jumptimer = 0
$Grinding = 0
$Fallen = 0
$FallenTimer = 0

vo("startlevel")
vo($level)
$OldStart = 0
for $iload = 0 to $ObjectsPerLevel
$ItemActive[$iload] = 1
$Item[$iload] = random(1, 300, 1)
$ItemSound[$iload][0] = s_load("fx\misc\Item.ogg")
S_Setvolume($ItemSound[$iload][0], -10000)
s_Play($ItemSound[$iload][0], 1)


Next
$Tempvar = 0
for $iload = 0 to $PipesPerLevel
$PipeStart[$iload] = $tempvar+Random(30, 50, 1)
$PipeEnd[$iload] = $PipeStart[$iload]+random(30, 50, 1)
$PipeSound[$iload] = s_load("FX\Misc\PipeGrind.ogg")
$Tempvar = $PipeEnd[$iload]
s_setvolume($PipeSound[$iload], -10000)
s_play($PipeSound[$iload], 1)
Next
for $iload = 0 to $JumpsPerLevel
$tempvar = $iload
$Objectstart[$iload] = $OldStart+random(10, 30, 1)
$ObjectEnd[$iload] = $Objectstart[$iload]+random(10, 20, 1)
$ObjectStartSound[$iload] = s_load("FX\Misc\AreaStart.ogg")
$ObjectEndSound[$iload] = s_Load("FX\Misc\AreaEnd.ogg")
S_Setvolume($ObjectStartSound[$iload], -10000)
S_Setvolume($ObjectEndSound[$iload], -10000)
s_play($ObjectStartSound[$iload], 1)
s_Play($ObjectEndSound[$iload], 1)
$OldStart = $ObjectEnd[$iload]

Next
Loop()

EndFunc
func Loop()
clipput("loop")
s_setvolume($FXAmbience[0], 0)
s_play($FXAmbience[0], 1)
s_play($fxmusic[0], 1)
S_SetVolume($FXMusic[0], $MusicVolume)

s_play($FXMisc[5], 1)

while 1

if winactive("ScapeSkate ~ A DragonApps Game") then
$Looptimer = TimerInit()
CheckScore()
CheckKeys()
CheckTimers()
CheckPosition()
PanStuff()

Else
Pausegame()
EndIf
WEnd
EndFunc
func CheckScore()
clipput("checkscore")
if $newbiemode = 0 then
if $score < -5000 then
ClearSounds()
vo("scoregameover")
ShowMenu()
EndIf
EndIf
EndFunc
func CheckPosition()
clipput("Checkposition")
if $piping = 1 then
if $Yourpos > $ToPipeTo then JumpFromPipe()
if $Yourpos < $ToPipeFrom-1 then FallFromPipe()
EndIf
if $jumping = 1 then
if $piping = 0 then
for $iload = 0 to $PipesPerLevel
if $yourpos > $PipeStart[$iload]-1 and $yourpos < $PipeStart[$iload]+1 then
$Piping = 1
s_play($FXSkate[17])
$ToPipeFrom = $PipeStart[$iload]
$ToPipeTo = $PipeEnd[$iload]
$Grinding = 0
EndIf
Next
EndIf
EndIf
if $yourpos > $ObjectEnd[$JumpsPerLevel]+20 then LevelUp()
for $iload = 0 to $ObjectsPerLevel
if $Jumping = 1 or $piping = 1 then
if $ItemActive[$iload] = 1 then
if $yourpos > $Item[$iload]-1 and $Yourpos < $Item[$iload]+1 then
if $newbiemode = 0 then $Score = $score+250
s_play($FXGetObject)
s_stop($ItemSound[$iload][0])
$ItemActive[$iload] = 0
EndIf
EndIf
EndIf
Next
if $Grinding = 1 then
if $yourpos > $ToMoveTo[0] and $Yourpos < $ToMoveTo[1] then
s_stop($FXSkate[4])
s_play($FXSkate[Random(5, 7, 1)])

$Grinding = 0
$Jumping = 1
$JumpTimer = TimerInit()
if $newbiemode = 0 then $Score = $Score+250
EndIf




EndIf
if $Grinding = 0 and $piping = 0 then
for $iload = 0 to $JumpsPerLevel
$TempVar = $iload
if $Yourpos > $ObjectStart[$iload] and $Yourpos < $ObjectEnd[$iload] then
if $Bumped = 0 then
if $jumping = 0 then
FallDown()
ExitLoop
EndIf
if $jumping = 1 then
if $SkateDirection = 2 then
FallDown()
ExitLoop
EndIf
if $SkateDirection = 1 then
$ToMoveTo[0] = $ObjectEnd[$iload] +1
$ToMoveTo[1] = $ObjectEnd[$iload] +1+1
EndIf
$Jumping = 0
$Grinding = 1
s_stop($fxskate[12])
if $newbiemode = 0 then $Score = $Score+50
EndIf
EndIf
if $yourpos > $ObjectStart[$iload] and $yourpos < $ObjectStart[$iload]+2 then

if $SkateDirection = 1 then
BumpAgainst()
Else
$TempVar = $Iload
$ToMoveTo[0] = $ObjectStart[$iload] -1
$ToMoveTo[1] = $ObjectStart[$iload] -1-1
FallDown()
EndIf
EndIf
EndIf


Next
EndIf
EndFunc
func CheckKeys()
clipput("CheckKeys")
if _ispressed($t) and $SayScore = 0 then TellLoopTime()
if _ispressed($s) and $SayScore = 0 then TellScore()
if not _ispressed($s) and $SayScore = 1 then $SayScore = 0
if _ispressed($p) and $paused = 0 then PauseGame()
if _ispressed($Page_Down) then
if s_GetVolume($FXMusic[0]) > -5000 then
S_SetVolume($FXMusic[0], s_GetVolume($FXMusic[0])-100)
$MusicVolume = s_getvolume($FXMusic[0])
EndIf
EndIf
if _ispressed($Page_Up) then
if s_GetVolume($FXMusic[0]) < 0 then
S_SetVolume($FXMusic[0], s_GetVolume($FXMusic[0])+100)
$MusicVolume = s_getvolume($FXMusic[0])
EndIf
EndIf
if _ispressed($Spacebar) then Jump()
if _ispressed($Escape) then ReturnToMain()
if _ispressed($right)  and $fallen = 0 then SkateRight()


if _ispressed($left) and $Fallen = 0 and $yourpos > 0 then SkateLeft()
if _ispressed($right) and $piping = 1 and $grinding = 0 and $fallen = 0 then SlideRight()


if _ispressed($left) and $piping = 1 and $Fallen = 0 and $yourpos > 0 then SlideLeft()

if _ispressed($UP)  and $Fallen = 0 then GrindRight()
if not _ispressed($up) and $grinding = 1 then FallDown()


if not _ispressed($right) and not _ispressed($left) and $skating = 1 then StopSkating()
EndFunc
func PanStuff()
clipput("panstuff")
Generate_pan($Yourpos, $ObjectEnd[$JumpsPerLevel]+20, 200, 200, $FXMisc[5])
for $iload = 0 to $PipesPerLevel
generate_Pan($Yourpos, $PipeStart[$iload], 200, 200, $PipeSound[$iload])
Next
for $iload = 0 to $ObjectsPerLevel
if $ItemActive[$iload] = 1 then
Generate_pan($Yourpos, $Item[$iload], 200, 200, $ItemSound[$iload][0])

EndIf
Next
for $iload = 0 to $JumpsPerLevel
Generate_pan($Yourpos, $ObjectStart[$iload], 200, 200,  $ObjectStartSound[$iload])
Generate_pan($Yourpos, $ObjectEnd[$iload], 200, 200, $ObjectEndSound[$iload])
Next
EndFunc
func SkateRight()
clipput("skateright")
if timerdiff($Movetimer) > 50 then
$Movetimer = timerinit()
if $grinding = 0 then
if $Bumped = 0 then
if $JustSkated = 1 then
;PlayerFall()
Else
if $skating = 0 then
$Skating = 1
s_play($fxSkate[11])
$SkateDirection = 1
EndIf
if $skating = 1 then
if $SkateDirection = 2 then
PlayerFall()

Else
if not s_isplaying($fxSkate[12]) and $jumping = 0 then s_play($fxskate[12], 1)
$Yourpos = $yourpos+$SkateSpeed
EndIf
EndIf
EndIf
EndIf
EndIf
EndIf
EndFunc
func SkateLeft()
clipput("skateleft")
if Timerdiff($movetimer) > 50 then
$Movetimer = TimerInit()
if $grinding = 0 then
if $Bumped = 0 then
if $JustSkated = 1 then
;PlayerFall()
else
if $skating = 0 then
$Skating = 1
if not s_isplaying($fxskate[11]) then s_play($fxSkate[11])
$SkateDirection = 2
EndIf
if $skating = 1 then
if $SkateDirection = 1 then
PlayerFall()

Else
if not s_isplaying($fxSkate[12]) and $jumping = 0 then s_play($fxskate[12], 1)
$Yourpos = $yourpos-$SkateSpeed
EndIf
EndIf
EndIf
EndIf
EndIf
EndIf
EndFunc
Func StopGrinding()
clipput("StopGrinding")
s_stop($fxskate[12])
if $Grinding = 1 then PlayerFall()
EndFunc
Func StopSkating()
clipput("StopSkating")
if $Piping = 1 then FallFromPipe()
$JustSkated = 1
$JustSkatedTimer = Timerinit()
s_stop($FXSkate[12])
s_play($FXSkate[15])
$Skating = 0
EndFunc
Func PlayerFall()
clipput("PlayerFall")
$Piping = 0
s_stop($FXPlayer[3])
s_stop($fxskate[12])
if $Fallen = 0 then
s_stop($FXSkate[4])
$Grinding = 0
$Skating = 0
$Fallen = 1
$FallenTimer = TimerInit()
s_stop($FXSkate[12])
if $newbiemode = 0 then $Score = $score-500
s_play($FXSkate[random(0, 2, 1)])
s_play($fxPlayer[2])
s_play($fxMisc[4])
EndIf
EndFunc
Func CheckTimers()
clipput("CheckTimers")
if $Grinding = 1 then $TempvarTwo = 250
if $Grinding = 0 then $TempVarTwo = 700
if $Jumping = 1 and Timerdiff($Jumptimer) > $TempVarTwo then
s_play($fxSkate[random(8, 10, 1)])
$Jumping = 0
;$Skatespeed = $toSetSpeed
EndIf
if $Bumped = 1 and Timerdiff($BumpedTimer) > 1000 then $Bumped = 0
if $JustSkated = 1 and TimerDiff($JustSkatedTimer) > 1000 then $JustSkated = 0
If $Fallen = 1 and timerdiff($FallenTimer) > 2000 then $Fallen = 0
EndFunc
Func BumpAgainst()
clipput("BumpAgainst")
if $Bumped = 0 then
$Bumped = 1
s_stop($fxskate[12])
s_play($FXSkate[16])
s_play($FXPlayer[0])
$BumpedTimer = TimerInit()
EndIf

EndFunc
Func Jump()
clipput("Jump")
if $Jumping = 0 then
if $piping = 1 then EnterSpecialMode()
$Jumping = 1
s_stop($fxskate[12])
if $newbiemode = 0 then $score = $score-50
s_stop($FXSkate[12])
s_play($FXSkate[Random(5, 7, 1)])
$Jumptimer = TimerInit()
;$SkateSpeed = $ToSetSpeed+0.25
EndIf
EndFunc
func FallDown()
clipput("FallDown")
s_play($FXPlayer[3])
s_stop($FXSkate[4])
s_stop($fxskate[12])
$ToMoveTo[0] = $ObjectStart[$TempVar] -1
$ToMoveTo[1] = $ObjectStart[$TempVar] -1-1
$piping = 0
if $grinding = 1 then $grinding = 0
s_stop($FXSkate[12])
if $newbiemode = 0 then $Score = $Score-250
while $yourpos > $ToMoveTo[0]-3
if TimerDiff($MoveTimer) > 20 then
$MoveTimer = TimerInit()
$Yourpos = $Yourpos-0.7
EndIf
PanStuff()

WEnd
PlayerFall()
EndFunc
func GrindRight()
clipput("GrindRight")
if $piping = 0 then
if $skating = 0 then
if $Grinding = 1 then
if Timerdiff($MoveTimer) > 25 then
$Movetimer = TimerInit()
s_stop($FXSkate[12])
if not s_isplaying($fxSkate[4]) then s_play($FXSkate[4])

$Yourpos = $Yourpos+$Skatespeed+0.15
EndIf
EndIf
EndIf
EndIf
EndFunc
func ReturnToMain()
ClearSounds()
ShowMenu()
EndFunc
func ClearSounds()
s_stop(-1)
for $iload = 0 to $PipesPerLevel

S_free($PipeSound[$iload])
Next
for $iload = 0 to $JumpsPerLevel

s_Free($ObjectStartSound[$iload])

s_Free($ObjectEndSound[$iload])
Next
for $iload = 0 to $ObjectsPerLevel
$ItemActive[$iload] = 0

s_free($ItemSound[$iload][0])
Next





EndFunc
Func LevelUp()
s_stop($FXMisc[5])
ClearSounds()
$Jumping = 0
$Grinding = 0
$yourpos = 0
if $newbiemode = 0 then
$level = $level+1
if $pipesperlevel < 10 then $pipesperlevel = $pipesperlevel+1
vo("Levelup")
vo("level")
vo($level)
vo("score")
if $newbiemode = 0 then vo($score)
if $newbiemode = 1 then vo("NewbieMode")
if $ObjectsPerLevel < 40 then $ObjectsPerLevel = $objectsperlevel+2
if $JumpsPerLevel < 40 then $JumpsPerLevel = $JumpsPerLevel+2
StartGame()
Else
ShowMenu()
EndIf
EndFunc
func TellScore()
$SayScore = 1
if $newbiemode = 0 then vo($score)
if $newbiemode = 1 then vo("NewbieMode")
EndFunc
func Pausegame()
StopSkating()
if $grinding = 1 then
$grinding = 0
FallDown()
EndIf
if $jumping = 1 then
$jumping = 0
EndIf
$paused = 1
s_stop($FXMusic[0])
s_stop($FXAmbience[0])
for $iload = 0 to $objectsperlevel
s_stop($Itemsound[$iload][0])
Next
for $iload = 0 to $JumpsPerLevel
s_stop($ObjectStartSound[$iload])
s_stop($ObjectEndSound[$iload])
Next
for $iload = 0 to $PipesPerLevel
s_stop($PipeSound[$iload])
Next
s_SetVolume($FXMusic[2], -2000)
s_play($FXMusic[2], 1)
if winactive("ScapeSkate ~ A DragonApps Game") then
speak ("Game paused. Press Enter to resume.", 2+1)
else
speak ("no! Please! Please don't leave me! Will you come back? If you do, press enter to resume gameplay!", 2+1)
EndIf
while $paused = 1
if winactive("ScapeSkate ~ A DragonApps Game") then
if _ispressed($s) and $SayScore = 0 then TellScore()
if not _ispressed($s) and $SayScore = 1 then $SayScore = 0
if _ispressed($enter) then $paused = 0
if _ispressed($Page_Down) then
if s_GetVolume($FXMusic[2]) > -5000 then
S_SetVolume($FXMusic[2], s_GetVolume($FXMusic[2])-100)

EndIf
EndIf
if _ispressed($Page_Up) then
if s_GetVolume($FXMusic[2]) < 0 then
S_SetVolume($FXMusic[2], s_GetVolume($FXMusic[2])+100)

EndIf
EndIf
if _ispressed($Escape) then ReturnToMain()
endIf
sleep(5)
WEnd
s_stop($FXMusic[0])
s_play($FXAmbience[0], 1)
for $iload = 0 to $PipesPerLevel
s_play($PipeSound[$iload], 1)
Next
for $iload = 0 to $objectsperlevel

if $Itemactive[$iload] = 1 then s_play($Itemsound[$iload][0], 1)
Next
for $iload = 0 to $JumpsPerLevel
s_play($ObjectStartSound[$iload], 1)
s_play($ObjectEndSound[$iload], 1)
Next


s_stop($FXMusic[2])
s_play($FXMusic[0], 1)
EndFunc
func FallFromPipe()
s_play($FXPlayer[3])
s_stop($FXSkate[4])
S_Stop($FXSkate[3])
$Temptimer = timerInit()
$height = random(500, 1000, 1)
while timerdiff($TempTimer) < $Height
sleep(5)
WEnd
$Piping = 0
FallDown()
EndFunc
Func SlideRight()
if TimerDiff($Movetimer) > 25 then
$MoveTimer = TimerInit()
s_stop($FXSkate[4])
S_Stop($FXSkate[12])
if not s_isplaying($FXSkate[3]) then s_play($FXSkate[3])
$Yourpos = $Yourpos+$Skatespeed+0.3
EndIf
EndFunc
Func SlideLeft()
if TimerDiff($Movetimer) > 25 then
$MoveTimer = TimerInit()
s_stop($FXSkate[4])
S_Stop($FXSkate[12])
if not s_isplaying($FXSkate[3]) then s_play($FXSkate[3])
$Yourpos = $Yourpos-($Skatespeed+0.25)
EndIf
EndFunc
func EnterSpecialMode()
$JustDidTrick = 0
s_stop($FXSkate[3])
s_stop($FXMusic[0])

$Freq = s_getfreq($FXAmbience[0])
s_setfreq($FXAmbience[0], $Freq/2)
for $iload = 0 to $objectsperlevel
s_stop($Itemsound[$iload][0])
Next
for $iload = 0 to $JumpsPerLevel
s_stop($ObjectStartSound[$iload])
s_stop($ObjectEndSound[$iload])
Next
for $iload = 0 to $PipesPerLevel
s_stop($PipeSound[$iload])
Next
$SlowmoTimer = TimerInit()
for $iload = 0 to 19
$SpecialKeyPressed[$iload] = 0
Next
s_play($FXSlowmo[0])
sleep(1000)
$CurrentKey = 0
while timerDiff($Slowmotimer) < 3000
if winactive("ScapeSkate ~ A DragonApps Game") then
if TimerDiff($Slowmotimer) > 800 then
if not s_isplaying($FXSlowmo[2]) then s_play($FXSlowmo[2])
EndIf
if _ispressed($left) and $keyleft = 0 then
s_play($FXPressedKey)
$KeyLeft = 1
$SpecialKeyPressed[$CurrentKey] = 1
$CurrentKey = $CurrentKey+1
EndIf
if _ispressed($right) and $keyright = 0 then
s_play($FXPressedKey)
$KeyRight = 1
$SpecialKeyPressed[$CurrentKey] = 2
$CurrentKey = $CurrentKey+1
EndIf
if _ispressed($up) and $keyup = 0 then
s_play($FXPressedKey)
$Keyup = 1
$SpecialKeyPressed[$CurrentKey] = 3
$CurrentKey = $CurrentKey+1
EndIf
if _ispressed($down) and $keydown = 0 then
s_play($FXPressedKey)
$KeyDown = 1
$SpecialKeyPressed[$CurrentKey] = 4
$CurrentKey = $CurrentKey+1
EndIf
if not _ispressed($left) and $Keyleft = 1 then $keyleft = 0
if not _ispressed($right) and $KeyRight = 1 then $keyRight = 0
if not _ispressed($up) and $Keyup = 1 then $keyup = 0
if not _ispressed($down) and $Keydown = 1 then $keydown = 0
if $CurrentKey > 2 then 
s_play($FXWrongMove)
if $newbiemode = 0 then $Score = $score-250
$Currentkey = 0
EndIf
CheckSpecialKeys()

else
ExitLoop
EndIf
WEnd
s_setfreq($FXAmbience[0], $freq)
s_play($FXSlowmo[1])
$piping = 0
$Jumping = 1
$jumptimer = TimerInit()
for $iload = 0 to $PipesPerLevel
s_play($PipeSound[$iload], 1)
Next
for $iload = 0 to $objectsperlevel

if $Itemactive[$iload] = 1 then s_play($Itemsound[$iload][0], 1)
Next
for $iload = 0 to $JumpsPerLevel
s_play($ObjectStartSound[$iload], 1)
s_play($ObjectEndSound[$iload], 1)
Next
s_play($FXMusic[0])
EndFunc
func CheckSpecialKeys()

if $SpecialKeyPressed[0] = 3 and $SpecialKeyPressed[1] = 4 and $JustDidTrick <> 1 then
$JustDidTrick = 1
s_play($FXSlowmo[4])
s_play($FXGetObject)
if $newbiemode = 0 then $score = $score+250
ResetSpecialKeys()
EndIf
if $SpecialKeyPressed[0] = 4 and $SpecialKeyPressed[1] = 3 and $JustDidTrick <> 2 then
$JustDidTrick = 2
s_play($FXSlowmo[5])
s_play($FXGetObject)
if $newbiemode = 0 then $score = $score+250
ResetSpecialKeys()
EndIf
if $SpecialKeyPressed[0] = 1 and $SpecialKeyPressed[1] = 2 and $JustDidTrick <> 3 then
$JustDidTrick = 3
s_play($FXSlowmo[6])
s_play($FXGetObject)
if $newbiemode = 0 then $score = $score+250
ResetSpecialKeys()
EndIf
if $SpecialKeyPressed[0] = 2 and $SpecialKeyPressed[1] = 1 and $JustDidTrick <> 4 then
$JustDidTrick = 4
s_play($FXSlowmo[7])
s_play($FXGetObject)
if $newbiemode = 0 then $score = $score+250
ResetSpecialKeys()
EndIf
EndFunc
func ResetSpecialKeys()
$CurrentKey = 0
for $iload = 0 to 4
$SpecialKeyPressed[$iload] = 0
Next
EndFunc
func TellLoopTime()

vo(timerdiff($LoopTimer))
EndFunc
func JumpFromPipe()
s_stop($FXSkate[3])

$piping = 0
Jump()
if $newbiemode = 0 then $score = $score+50
EndFunc